var NAVTREE =
[
  [ "AirRAC", "index.html", [
    [ "AirRAC Documentation", "index.html", null ],
    [ "People", "authors.html", [
      [ "Project Admins (and Developers)", "authors.html#admins", null ],
      [ "Retired Developers", "authors.html#retired", null ],
      [ "Contributors", "authors.html#contributors", null ],
      [ "Distribution Maintainers", "authors.html#distributors", null ]
    ] ],
    [ "Coding Rules", "coding_rules.html", [
      [ "Default Naming Rules for Variables", "coding_rules.html#cr_variables", null ],
      [ "Default Naming Rules for Functions", "coding_rules.html#cr_functions", null ],
      [ "Default Naming Rules for Classes and Structures", "coding_rules.html#cr_classes", null ],
      [ "Default Naming Rules for Files", "coding_rules.html#cr_files", null ],
      [ "Default Functionality of Classes", "coding_rules.html#cr_classes_functionality", null ]
    ] ],
    [ "Copyright and License", "copyright.html", [
      [ "GNU LESSER GENERAL PUBLIC LICENSE", "copyright.html#gnugpl", [
        [ "Version 2.1, February 1999", "copyright.html#version", null ]
      ] ],
      [ "Preamble", "copyright.html#preamble", null ],
      [ "TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION", "copyright.html#terms", [
        [ "NO WARRANTY", "copyright.html#nowarranty", null ],
        [ "END OF TERMS AND CONDITIONS", "copyright.html#endofterms", null ]
      ] ],
      [ "How to Apply These Terms to Your New Programs", "copyright.html#howtoapply", null ]
    ] ],
    [ "Documentation Rules", "documentation.html", [
      [ "General Rules", "documentation.html#doc_general", null ],
      [ "File Header", "documentation.html#doc_header", null ],
      [ "Grouping Various Parts", "documentation.html#doc_groups", null ]
    ] ],
    [ "Main features", "features.html", [
      [ "Yield calculation", "features.html#ft_yield_calculation", null ],
      [ "Yield rule engine", "features.html#ft_yield_rule_engine", null ],
      [ "Yield retrieval", "features.html#ft_yield_retrieval", null ],
      [ "Other features", "features.html#ft_others", null ]
    ] ],
    [ "Make a Difference", "help_wanted.html", null ],
    [ "Make a new release", "howto_release.html", [
      [ "Introduction", "howto_release.html#description", null ],
      [ "Initialisation", "howto_release.html#initialisation", null ],
      [ "Branch creation", "howto_release.html#branch_creation", null ],
      [ "Commit and publish the release branch", "howto_release.html#branch_publish", null ],
      [ "Update the change-log in the trunk as well", "howto_release.html#trunk_update", null ],
      [ "Create distribution packages", "howto_release.html#create_packages", null ],
      [ "Generation the RPM packages", "howto_release.html#generate_rpm_packages", null ],
      [ "Update distributed change log", "howto_release.html#update_changelog", null ],
      [ "Create the binary package, including the documentation", "howto_release.html#create_bin_packages", null ],
      [ "Upload the files to SourceForge", "howto_release.html#upload_files", null ],
      [ "Upload the documentation to SourceForge", "howto_release.html#upload_doc", null ],
      [ "Make a new post", "howto_release.html#post_news", null ],
      [ "Send an email on the announcement mailing-list", "howto_release.html#send_announce", null ]
    ] ],
    [ "Installation", "installation.html", [
      [ "Table of Contents", "installation.html#toc", null ],
      [ "Fedora/RedHat Linux distributions", "installation.html#rpm_linux", null ],
      [ "AirRAC Requirements", "installation.html#requirements", null ],
      [ "Basic Installation", "installation.html#basic_instructions", null ],
      [ "Compilers and Options", "installation.html#compilers", null ],
      [ "Compiling For Multiple Architectures", "installation.html#compiling_for_multi_arch", null ],
      [ "Installation Names", "installation.html#installation_names", null ],
      [ "Optional Features", "installation.html#optional_features", null ],
      [ "Particular systems", "installation.html#particular_systems", null ],
      [ "Specifying the System Type", "installation.html#specifying_system_type", null ],
      [ "Sharing Defaults", "installation.html#sharing_defaults", null ],
      [ "Defining Variables", "installation.html#defining_variables", null ],
      [ "`cmake' Invocation", "installation.html#cmake_invocation", null ]
    ] ],
    [ "Linking with AirRAC", "linking.html", [
      [ "Table of Contents", "linking.html#toc", null ],
      [ "Introdution", "linking.html#intro", null ],
      [ "Using the pkg-config command", "linking.html#pkgconfig", null ],
      [ "Using the airrac-config script", "linking.html#airrac_config", null ],
      [ "M4 macro for the GNU Autotools", "linking.html#autotools", null ],
      [ "Using AirRAC with dynamic linking", "linking.html#dynamiclinking", null ]
    ] ],
    [ "Test Rules", "test.html", [
      [ "The Test Source Files", "test.html#test_source", null ],
      [ "The Reference File", "test.html#reference_file", null ],
      [ "Testing AirRAC Library", "test.html#testing_using_make", null ]
    ] ],
    [ "Users Guide", "users_guide.html", [
      [ "Table of Contents", "users_guide.html#ug_toc", null ],
      [ "Introduction", "users_guide.html#ug_introduction", null ],
      [ "Get Started", "users_guide.html#ug_get_started", [
        [ "Get the AirRAC library", "users_guide.html#ug_get_source", null ],
        [ "Build the AirRAC project", "users_guide.html#ug_build_binaries", null ],
        [ "Build and Run the Tests", "users_guide.html#ug_build_and_run_tests", null ],
        [ "Install the AirRAC Project (Binaries, Documentation)", "users_guide.html#ug_install_project", null ]
      ] ],
      [ "Exploring the Predefined BOM Tree", "users_guide.html#ug_bom_tree", [
        [ "Yield Rule Engine BOM Tree", "users_guide.html#ug_bom_yield_rule_engine", null ]
      ] ],
      [ "Extending the BOM Tree", "users_guide.html#ug_extending_bom_tree", null ]
    ] ],
    [ "Supported Systems", "verification.html", [
      [ "Table of Contents", "verification.html#toc", null ],
      [ "Introdution", "verification.html#intro", null ],
      [ "AirRAC 0.1.x", "verification.html#airrac_0_1", [
        [ "Linux Systems", "verification.html#linux", [
          [ "Fedora Core 4 with ATLAS", "verification.html#fedora_atlas", null ],
          [ "Gentoo Linux with ACML", "verification.html#gentoo_acml", null ],
          [ "Gentoo Linux with ATLAS", "verification.html#gentoo_atlas", null ],
          [ "Gentoo Linux with MKL", "verification.html#gentoo_mkl", null ],
          [ "Gentoo Linux with NetLib's BLAS and LAPACK", "verification.html#gentoo_netlib", null ],
          [ "Red Hat Enterprise Linux with AirRAC External", "verification.html#rhel", null ],
          [ "SUSE Linux 10.0 with NetLib's BLAS and LAPACK", "verification.html#suse_netlib", null ],
          [ "SUSE Linux 10.0 with MKL", "verification.html#suse_mkl", null ]
        ] ],
        [ "Windows Systems", "verification.html#windows", [
          [ "Microsoft Windows XP with Cygwin", "verification.html#cygwin", null ],
          [ "Microsoft Windows XP with Cygwin and ATLAS", "verification.html#cygwin_atlas", null ],
          [ "Microsoft Windows XP with Cygwin and ACML", "verification.html#cygwin_acml", null ],
          [ "Microsoft Windows XP with MinGW, MSYS and ACML", "verification.html#mingw_acml", null ],
          [ "Microsoft Windows XP with MinGW, MSYS and AirRAC External", "verification.html#mingw_netlib", null ],
          [ "Microsoft Windows XP with MS Visual C++ and Intel MKL", "verification.html#msvc_mkl", null ]
        ] ],
        [ "Unix Systems", "verification.html#unix", [
          [ "SunOS 5.9 with AirRAC External", "verification.html#sunos59", null ]
        ] ]
      ] ]
    ] ],
    [ "AirRAC Supported Systems (Previous Releases)", "verification_old.html", [
      [ "AirRAC 3.9.1", "verification_old.html#airrac_3_9_1", null ],
      [ "AirRAC 3.9.0", "verification_old.html#airrac_3_9_0", null ],
      [ "AirRAC 3.8.1", "verification_old.html#airrac_3_8_1", null ]
    ] ],
    [ "Tutorials", "tutorials.html", [
      [ "Table of Contents", "tutorials.html#tut_toc", null ],
      [ "Introduction", "tutorials.html#tut_introduction", [
        [ "Preparing the AirRAC Project for Development", "tutorials.html#tut_intro_configuration", null ]
      ] ],
      [ "Build a Predefined BOM Tree", "tutorials.html#tut_build_bom_tree", [
        [ "Instanciate the BOM Root Object", "tutorials.html#tut_build_bom_root", null ],
        [ "Instanciate the (Airline) Inventory Object", "tutorials.html#tut_build_inventory", null ],
        [ "Link the Inventory Object with the BOM Root", "tutorials.html#tut_build_link", null ],
        [ "Build Another Airline Inventory", "tutorials.html#tut_build_inventory_another", null ],
        [ "Dump The BOM Tree Content", "tutorials.html#tut_dump_bom_tree", null ],
        [ "Result of the Tutorial Program", "tutorials.html#tut_result_output", null ]
      ] ]
    ] ],
    [ "Command-Line Test to Demonstrate How To Test the AirRAC Project", "YieldTestSuite_cpp.html", null ],
    [ "Namespaces", null, [
      [ "Namespace List", "namespaces.html", "namespaces" ],
      [ "Namespace Members", "namespacemembers.html", [
        [ "All", "namespacemembers.html", null ],
        [ "Variables", "namespacemembers_vars.html", null ],
        [ "Typedefs", "namespacemembers_type.html", null ]
      ] ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", null ],
        [ "Functions", "functions_func.html", null ],
        [ "Variables", "functions_vars.html", null ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", null ],
        [ "Functions", "globals_func.html", null ],
        [ "Variables", "globals_vars.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Macros", "globals_defs.html", null ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
".html",
"structAIRRAC_1_1YieldParserHelper_1_1YieldRuleParser.html#a938337b056ef449295351ee9301eeecd",
];

var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode) {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  imgNode.width = 16;
  imgNode.height = 22;
  if (level==0 && node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast) {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        } else {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  } else {
    domNode.appendChild(imgNode);
  }
  if (level==0) {
    if (node.isLast) {
      if (node.childrenData) {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      } else {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    } else {
      if (node.childrenData) {
        imgNode.src = node.relpath+"ftv2pnode.png";
      } else {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  } else {
    if (node.isLast) {
      imgNode.src = node.relpath+"ftv2blank.png";
    } else {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : '#';
      a.onclick = function(){
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var pos, anchor = $(aname), docContent = $('#doc-content');
        if (anchor.parent().attr('class')=='memItemLeft') {
          pos = anchor.parent().position().top;
        } else if (anchor.position()) {
          pos = anchor.position().top;
        }
        if (pos) {
          var dist = Math.abs(Math.min(
                     pos-docContent.offset().top,
                     docContent[0].scrollHeight-
                     docContent.height()-docContent.scrollTop()));
          docContent.animate({
            scrollTop: pos + docContent.scrollTop() - docContent.offset().top
          },Math.max(50,Math.min(500,dist)),function(){
            window.location.replace(aname);
          });
        }
      };
    } else {
      a.href = url;
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var anchor = $($(location).attr('hash'));
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
}

function selectAndHighlight(n)
{
  var a;
  if ($(location).attr('hash')) {
    var link=stripPath($(location).attr('pathname'))+':'+
      $(location).attr('hash').substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  showRoot();
}

function showNode(o, node, index)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index); // retry with child node expanded
          },true);
        } else {
          var rootBase = o.toroot.replace(/\..+$/, '');
          if (rootBase=="index" || rootBase=="pages") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(n);
        }
      }
    }
  } else {
    selectAndHighlight();
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = nti ? nti : navTreeSubIndices[subIndex][root];
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0);
  }
}

function navTo(o,root,hash,relpath)
{
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     }
  })

  $(window).load(showRoot);
}

